org.eclipse.jetty.util

## Class TypeUtil

- java.lang.Object
- - org.eclipse.jetty.util.TypeUtil

    public class TypeUtil
    extends Object

TYPE Utilities. Provides various static utiltiy methods for manipulating types and their string representations.

Since:
  Jetty 4.1

### Field Summary

Fields
`static int` `CR`
`static int` `LF`

### Constructor Summary

Constructors
Constructor and Description
`TypeUtil()`

### Method Summary

Methods
`static <T> List<T>` `asList(T[] a)` Array to List.
`static Object` `call(Class<?> oClass, String method, Object obj, Object[] arg)`
`static byte` `convertHexDigit(byte b)`
`static void` `dump(Class<?> c)`
`static void` `dump(ClassLoader cl)`
`static byte[]` `fromHexString(String s)`
`static Class<?>` `fromName(String name)` Class from a canonical name for a type.
`static URL` `jarFor(String className)`
`static byte[]` `parseBytes(String s, int base)`
`static int` `parseInt(byte[] b, int offset, int length, int base)` Parse an int from a byte array of ascii characters.
`static int` `parseInt(String s, int offset, int length, int base)` Parse an int from a substring.
`static byte[]` `readLine(InputStream in)`
`static void` `toHex(byte b, Appendable buf)`
`static String` `toHexString(byte b)`
`static String` `toHexString(byte[] b)`
`static String` `toHexString(byte[] b, int offset, int length)`
`static String` `toName(Class<?> type)` Canonical name for a type.
`static String` `toString(byte[] bytes, int base)`
`static Object` `valueOf(Class<?> type, String value)` Convert String value to instance.
`static Object` `valueOf(String type, String value)` Convert String value to instance.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### CR

    public static int CR

#### LF

    public static int LF

### Constructor Detail

#### TypeUtil

    public TypeUtil()

### Method Detail

#### asList

    public static <T> List<T> asList(T[] a)

Array to List.

Works like `Arrays.asList(Object...)`, but handles null arrays.

Returns:
  a list backed by the array.

#### fromName

    public static Class<?> fromName(String name)

Class from a canonical name for a type.

Parameters:
  `name` - A class or type name.
Returns:
  A class , which may be a primitive TYPE field..

#### toName

    public static String toName(Class<?> type)

Canonical name for a type.

Parameters:
  `type` - A class , which may be a primitive TYPE field.
Returns:
  Canonical name.

#### valueOf

    public static Object valueOf(Class<?> type,
                 String value)

Convert String value to instance.

Parameters:
  `type` - The class of the instance, which may be a primitive TYPE field.
  `value` - The value as a string.
Returns:
  The value as an Object.

#### valueOf

    public static Object valueOf(String type,
                 String value)

Convert String value to instance.

Parameters:
  `type` - classname or type (eg int)
  `value` - The value as a string.
Returns:
  The value as an Object.

#### parseInt

    public static int parseInt(String s,
               int offset,
               int length,
               int base)
                        throws NumberFormatException

Parse an int from a substring. Negative numbers are not handled.

Parameters:
  `s` - String
  `offset` - Offset within string
  `length` - Length of integer or -1 for remainder of string
  `base` - base of the integer
Returns:
  the parsed integer
Throws:
  `NumberFormatException` - if the string cannot be parsed

#### parseInt

    public static int parseInt(byte[] b,
               int offset,
               int length,
               int base)
                        throws NumberFormatException

Parse an int from a byte array of ascii characters. Negative numbers are not handled.

Parameters:
  `b` - byte array
  `offset` - Offset within string
  `length` - Length of integer or -1 for remainder of string
  `base` - base of the integer
Returns:
  the parsed integer
Throws:
  `NumberFormatException` - if the array cannot be parsed into an integer

#### parseBytes

    public static byte[] parseBytes(String s,
                    int base)

#### toString

    public static String toString(byte[] bytes,
                  int base)

#### convertHexDigit

    public static byte convertHexDigit(byte b)

Parameters:
  `b` - An ASCII encoded character 0-9 a-f A-F
Returns:
  The byte value of the character 0-16.

#### toHex

    public static void toHex(byte b,
             Appendable buf)

#### toHexString

    public static String toHexString(byte b)

#### toHexString

    public static String toHexString(byte[] b)

#### toHexString

    public static String toHexString(byte[] b,
                     int offset,
                     int length)

#### fromHexString

    public static byte[] fromHexString(String s)

#### dump

    public static void dump(Class<?> c)

#### dump

    public static void dump(ClassLoader cl)

#### readLine

    public static byte[] readLine(InputStream in)
                           throws IOException

Throws:
  `IOException`

#### jarFor

    public static URL jarFor(String className)

#### call

    public static Object call(Class<?> oClass,
              String method,
              Object obj,
              Object[] arg)
                       throws InvocationTargetException,
                              NoSuchMethodException

Throws:
  `InvocationTargetException`
  `NoSuchMethodException`